%define	name	BitchX
%define	version	75p3
%define	release	1
%define	serial	2

Summary:	Improved color IRC client with built-in scripts
Name:		%{name}
Version:	%{version}
Release:	%{release}
Serial:		%{serial}
Group:		Applications/Communications
Copyright:	GPL
Vendor:		Colten Edwards <panasync@bitchx.com>
URL:		http://www.bitchx.org
Distribution:	Freshmeat RPMs
Packager:	Ryan Weaver <ryanw@infohwy.com>
Source:		ircii-pana-%{version}.tar.gz
Source1:	.config.h
Patch1:		BitchX.patch
BuildRoot:	/tmp/%{name}-%{version}
 
%description 
BitchX is a popular ANSI color ircII client by panasync. It
incorporates various features that would normally require a
script. It's interface is more colorful and cleaner than ircII.

%prep
%setup -q -n BitchX
%patch1 -p1

cp -p $RPM_SOURCE_DIR/.config.h .

%build
CFLAGS=$RPM_OPT_FLAGS \
./configure --prefix=/usr --with-tcl

cp -p Makefile Makefile.old

sed -e 's/^# CD_PLAY/CD_PLAY/g' \
    -e 's/^# CD_SRCS/CD_SRCS/g' \
    -e 's/^# CD_OBJS/CD_OBJS/g' \
    Makefile.old >Makefile

make

%install
if [ -d $RPM_BUILD_ROOT ]; then rm -r $RPM_BUILD_ROOT/ ; fi
mkdir -p $RPM_BUILD_ROOT/usr/{bin,man/man1}

strip source/BitchX
strip source/wserv
strip source/scr-bx

make prefix=$RPM_BUILD_ROOT/usr installbin
#make prefix=$RPM_BUILD_ROOT/usr installhelp

(cd $RPM_BUILD_ROOT/usr/bin;ln -sf BitchX-%{version} BitchX;cd $RPM_BUILD_DIR)

install -m755 install-bitchx $RPM_BUILD_ROOT/usr/bin

install -m644 BitchX.ircnames $RPM_BUILD_ROOT/usr/lib/bx
install -m644 BitchX.quit $RPM_BUILD_ROOT/usr/lib/bx
install -m644 BitchX.reasons $RPM_BUILD_ROOT/usr/lib/bx

rm -r bitchx-docs/CVS
cp -r bitchx-docs/* $RPM_BUILD_ROOT/usr/lib/bx/help
install -m644 BitchX.help $RPM_BUILD_ROOT/usr/lib/bx/help

install -m644 BitchX.1.gz $RPM_BUILD_ROOT/usr/man/man1

%clean
rm -rf $RPM_BUILD_ROOT

%files 
%defattr(-, root, root)
%doc doc/* BitchX.1.gz BitchX.help BitchX.ircnames BitchX.quit BitchX.reasons Changes
/usr/bin/BitchX-%{version}
/usr/bin/BitchX
/usr/bin/wserv
/usr/bin/scr-bx
/usr/bin/install-bitchx
/usr/man/man1/BitchX.1.gz
/usr/lib/bx

%post 
echo Type install-bitchx to install the configuration files to your home directory.

%changelog
* Mon Mar  1 1999 Ryan Weaver <ryanw@infohwy.com>
  [BitchX-75p3]
- Updated to version 75p3 final.
- No listings in ChangeLog

* Mon Feb 22 1999 Ryan Weaver <ryanw@infohwy.com>
  [BitchX-75p2]
- Upgraded to 75p2 final.
- fixed epic's /help so it works again.
- epic4nr16 changes merged in. This includes the key binding code.
- fixed a few problems with window_level which was an int, but should have
  been a unsigned long.
- Added a debugging window. If you /set debug will make ALL output from the 
  client's debugger appear on a hidden window. All normal output will 
  appear in the proper windows. DEBUG takes several parameters. COMMANDS,
  EXPANSIONS, TCL, FUNCTIONS, ALIAS, HOOK, VARIABLE. /set -debug will clear 
  this. ALIAS will debug specific alias's, which are specified with 
  /debug name. They can be removed with /debug -name
- fixed up userhost_ban() and various /ban /kick functions which were having
  trouble with nicks with a \ in them.
- DEFAULT_FONT was not working like it was supposed too... the exec needs
  the args split up instead of what we were doing.
- fixed problem in get_window_bound_channel() and a NULL pointer.
- Added a /spam command which takes a channel name. If compares the channel
  name with all other channels producing a list of nick@userhost's who are
  common on both channels.
- ruibarreiros@usa.net sent some patches for PTnet commands to be added.
  His patch was much simpler when added a little differently so he might
  not recognize his work. A #define was added to config.h for enabling 
  this WANT_CHAN_NICK_SERV.
- server splits in rapid succession could cause a mass kick too occur. We
  now do a little differant order of events within p_channel() and
  add_to_channel()
- Really really fixed AUTO_RECONNECT so that if it's off, not even a timed
  auto reconnect to the server will happen.
- Added timestamp logging in the /lastlog. -time will turn it off. There's
  also a /fset format_lastlog for output formatting. time in seconds is the
  first arg.
- Robohak noticed a problem with /exec - and no flags given.
- added /cdcc on/off commands. This will turn cddc on and off
- ajoin with a key was not being re-loaded properly from a BitchX.sav
- svobodam@eva.vsp.cz sent in some patches for bx.. Specifically adding
  ircnet support. His patch for lame_ident's was already implemented. Added
  some ircnet servers.
- some changes to the functions $opensocket(). Added a NOTIFY param as the
  third arg, default is line mode SOCKET reading. This changes the behaviour 
  of the socket. instead of the SOCKET, hook returning the info, another hook 
  SOCKET_NOTIFY is sent instead. IT's upto the script in this case too read 
  the socket. So either a $readsocket() or a $readchar() can be used to read
  the info from the socket. params on the hooks were changed to be a little
  more sane. "socketnum servername port flags" for SOCKET_NOTIFY and 
  "socketnum servername port string" for SOCKET.

* Fri Dec 18 1998 Ryan Weaver <ryanw@infohwy.com>
- Upgraded to version 75p2-10alpha
- [Changes 75p2]
- another major in-compatibility in scr-bx  added.. Make sure you update
  scr-bx. This one adds connection cookies. Without the cookie, you can't
  connect to a detached bx.
- /window 2 triple on was coring the client when window 2 was a hidden
  window. this might have effected other commands as well.
- bug in wset pointed out by void fixed.
- make configure check for in_systm.h in netinet and sys directories.
- added multi-play to internal amp module. quoted filenames are played one
  after another.
- small patch for HPUX modules. author of the patch said that he required
  a additional -DHPUX on the CFLAGS
- small bug in tab completions fixed. Added #chan completion into tab
  handling
- cosmetic changes to /cdcc involving the help.
- Robohak found and supplied a patch for the new /set mangle routines. Same
  patch applies to epic.
- away msg log removal broken when using /back.
- added a new /cset LAME_IDENT for turning off the ban/kick on lame chars in
  the ident. seems some servers all this shit.
- Robohak found and fixed two problems in $winitem().
- had a crack at fixing the term init problem when you change term sizes.
  this is not gonna be easy. currently it works. but it's a real kludge and
  not totally 100%. ie term types have to be the same. xterm != vt100.
  Changes required too scr-bx so the console size can be passed. This makes
  scr-bx in-compatible with older scr-bx's
- a few small changes made too detachcmd(). we now remove the
  ~/.BitchX/screens file on a TERM signal. This helps when reattaching to a
  cron'd BitchX process. We can use the same cron script as an egg.
- re-wrote whokill. /whokill pattern pattern pattern :reason will match
  the patterns and buffer the kills. on end, it then kills in groups to 
  help prevent flooding of the oper. Added NUM_KILLS variable. Requested
  by thetaz a dalnet oper. EfNet only allows one kill per KILL.
- -r filename will now accept a path/filename as well as just a filename.
- potential problem with a mode change corrected. This would cause the
  client to become desynced from the actual server modes.. 
  /c -lk-oo test nick nick1 too demonstrate. Thanks too SideWnder for this.
- ignoring ctcp no longer ignore's quits. First mentioned by Hyriluk
- removed FORMAT_USERS_BOT. it was redundant.
- added FORMAT_USERS_TITLE. default for FORMAT_USERS FORMAT_USERS_SHIT
  changed
- changed the split list so it's server dependant. This way, the list will
  still work on multiple servers.
- some problems in the shitlist now fixed. Also added new functionality.
  if a nick is on the channel and the shitlist is added, they are
  immediately banned and kicked. if they are unshit'd, and the ban is on 
  the channel the ban is removed as well. The following types of bans are 
  allowed -   nick, nick!user nick!user@host, user@host.
- error in nicklist hash causing core found. $checkuser(blah *) doesn't 
  core now.
- 471-476 numerics moved. these CAN hurt internal structures.
- substr, rsubstr, getopt, isaway and nohighlight functions added. 
- possible timer bug found/fixed.
- function for collecting number of users, written by Mhacker.
- minor changes made to nick completion.
- added a new hook MODULE, which can be called from dll modules and
  interface with scripts. for example, amp, returns a "AMP PLAY name" on
  start, a "AMP CLOSE name" on end, "AMP ERRROR name" and "AMP ID3 params".
- auto_response should be a bool on/off instead of a int. default it too on
- fixed a problem in the autobot module. should have been u->host
- kopz notice that dcc min speed was not working.. fixed. Also modified
  /cdcc minspeed so that it accepts 2 arguements. a minspeed and a timeout.
- Cset queuing is now fully implemented. You can even specify a cset in
  your .bitchxrc file. It will be queued up until you join that channel.
- more modifications to $aliasctl(). a PMATCH param can be specified which
  will search for wildcarded matches. MATCH does exact char matching.
- HARD_UH_NOTIFY is gone. along with it went NOTIFY_SIGNON_UH and
  NOTIFY_SIGNOFF_UH hooks. FORMAT_NOTIFY_SIGNON_UH FORMAT_NOTIFY_SIGNOFF_UH
  is gone as well. Userhost notification is now the default. /notify can now 
  accept a nick!user@host. All this means is that unless the userhost
  matches, this notify will not display. Some notify problems found and
  fixed.
- $getcset(var #chan value) will set a new value and return the old.
- Power found a problem with $winitem().
- Nuke found a solution for the problem with win95 and color. turns out that
  ansi.sys scroll region, doesn't scroll the color. stupid... Anyways, we
  changed to a direct windows function for scrolling a region and problem
  is now solved.
- replaced the dcc_*_func with something more generic. a 
  add_dcc_bind("type", "modname" init_func, open_func, input, output, 
		close_func);
	type is a char str defining the new dcc type.
	modname is the name of the module. for use when unloading.
	init_func is a function that is called when this ctcp type is
	recieved.
	open_func is a function that is called when the dcc is open'd.
	input is a function that should be called when there is data ready.
	output is a function to call when you send data.
	close_func is a function to call when the dcc is to be closed.
  we could actually replace internal routines with ones that are wanted.
  each of the above functions should return a int value. in some cases this
  value is ignored. but the input/output routines do NOT ignore this.
- change /dc to not chat yourself. Also changed /dcc chat to ignore your own
  nick.
- small change to $glob() to fix a memleak.
- more changes to tab_completion.
- added the ability for /scan to accept a wildcard nick!user@host to search
  for. so /scan *!*@*.com
- Implemented a queued server send system for use in cdcc. 
  /set QUEUE_SENDS #, where number is the number of seconds to wait.
- fixed up core problem with notify.
- merged in epic4 pre2.001nr-3 and partial pre2.001nr2 patches.
- remerged in the OS/2 pm port changes.
- added a CTCP userlist flag. which allows ctcps on certain ones when
  cloaked
- forgot about DCC_PROC for modules. added remove procedure.
- found bug with numeric 464.
- humble contributed a color change to bx. in config.h add a #define HUMBLE
  just before the #include "color.h" and it will be enabled as the default.
- added a $longcomma() which takes a long number, and formats it with
  comma's
- possible fix for core on netsplits with a * in them.

- added a couple of output replacement hooks for dcc and server connections.
	serv_output_func, serv_input_func, dcc_input_func and
	dcc_output_func can be defined within a module to replace the normal
	dgets() and write() functions. This paves the way for secure
	dcc/server connections.  serv_output_func = some_new_output; in your
	module.

- new TAB_COMPLETION binding created. A FORMAT_COMPLETE also added for
  display purposes. This new bind does alot more than the old TAB_MSG bind.
  commands currently specifically handled with the new tab complete are, 
  MSG/EXEC/DCC/LOAD/SERVER/LS
	- With nothing on the line, we cycle through the
	msg buffer nicks. if there are none, then the list of channel
	nicks is displayed.
	- if we start typing a nick, then matching channel nicks are
	displayed. if there's one and only one, then it will be
	placed on the input line
	- "/msg " will use the tab buffer, or if that's empty then
	we  use channel nicks. placing a partial nick, will match
	that nick from either.
	- "/exec [pattern]" will attempt to match a filename. if no
	path is specified, then your $HOME directory is assumed.
	if you use / then we can match directories. A * is implied
	when matching, so you don't have to supply one.
	- "/dcc send nick filename". depending on where you press
	the tab will determine what is done on the matching. if it's
	at the nick then tab/chan nick matching is done. if it at
	the filename, then DCC_DLDIR is used for matching.
	specifying a / means look in a dir other than DCC_DLDIR.
  this new tab_completion will also fill in the the input buffer with
  the most number of chars that are common from the resulting match.

- Added a -ALL flag to xquotecmd to send to all connected servers.
- found and fixed a problem with timed_server() which was causing a odd
  coredump with is.bx. 
- modified $aliasctl() for command globbing and assign globbing.
	$aliasctl(assign/local/alias/command get/set/match what);
	command globbing is a match only operation.
	local assigns don't make sense in a match operation.
	This will however return all matching assign's/alias's/commands.
	The "what" has a appended * so you if you don't specify 
	a wildcard. Contributed patch to epic.
- added /clear -scroll for cleaning out the scrollback buffer.
- the away msg is resent when we reconnect or timeout from a server. client
  no longer resends the away msg to your channels.
- format_server_notice changed. and more server notices now use the
  server_prompt variable
- Small change made to bx to support NAT. Added -Z flag to enable a userhost
  on connect to the server. This sets the address to use for dcc transfers.
  supposedly this is enough to get by the NAT server.
- # comments supported in .ircservers, ircII.servers etc. when found, we
  truncate the line at the #.
- added back in, dcc renumbering code. Possible though I didn't catch all
  the exits.
- configure --with-tcl patch added. This makes the configure script #define 
  WANT_TCL in defs.h instead of editing the Makefile. Allows modules to be
  compiled with tcl/non-tcl support as well.
- window logfile will now strip certain chars from the name and replace with
  '-'. This is so that nicks with "|\/:" don't cause problems in any of the
  clients but specifically with the win95/nt OS2 ports
- Added 2 new hooks. LEAVE_ME  is hooked when we part a channel under our
  own power. CHANOP is hooked when we gain ops in a channel.
- $dccitem() which will return information based on the passed in dcc number
  or socket number. args are a number (dccitem) or a #number (socketnum).
	$0 type
	$1 nick
	$2 status
	$3 start time 
	$4 start position for resume/reget/resend
	$5 bytes recieved
	$6 bytes sent
	$7 filesize
	$8 filename
	$9 socket number of this connect
	$10 server
- $winitem() added which is compatible in most respects with openirc's
  version. if %num then num is a window refnum. just a number then it's the 
  num'th window in the list. 
	$0 refnum
	$1 name or <none>
	$2 server number
	$3 current channel or <none>
	$4 query nick or none
	$5 waiting channel or <none>
	$6 <none> (oirc has menu name)
	$7 1 visible 0 non-visible.
	$8 # of columns
	$9 # of rows
	$10 reserved
	$11 reserved
	$12 reserved
	$13 reserved
	$14 reserved
	$15 logfile name or none
	$16 L if logging enabled, "" always apart of string
	$17 n if nicklist.
	$18-$19 reserved
	$20+ window level
- new flag to /clear -scrollback which will clear the scrollback buffer as 
  well as the window. /clear -scrollback -all works for all windows.
- $chanmode() extended. $chanmode(#chan #) where # can be 0 normal, 1 bans,
  2 ban whoset time, 3 exemptions for TS4.
     $chanmode(#bitchx 1)  ->  "*!*@*.aol.com"
     $chanmode(#bitchx 2)  ->  "*!*@*.aol.com elmer 9123000"
- $channicks() and $chanusers() can accept one more param. This is the sort
  type to use for call. types of sorting are 0 normal, 1 none, 2 nick,
  3 host, 4 time, 5 ip if available.
- NICK_COMPLETION_LEN added from a patch by by-tor
- some buffer modifications to reduce memory usage.
- some old function unused removed.
- old prototypes found and removed as well as unneeded ones.
- /kb fixed to not send -o the nick, as they are already kicked.
- modified module loading to make it possible to load on alot more systems
  that don't have -rdynamic flag for exporting symbols. Makes the client 
  250k smaller in size as well. Shouldn't impact memusage at all. Module
  interface changed though to make this possible. a pointer to a list of 
  functions is passed into the _Init function as well as the pointer to the
  command table. These functions can now be accessed using a file with
  "alot" of defines in it. modval.h created for this purpose. Internal
  functions could possibly be replaced using this method as well.
- Robohak contributed a patch to function_msar() which should concievably
  fix the memleak in it.
- Robohak reported a coredump in p_topic(). should be fixed. looks like a 
  really desynced condition could possibly exist that might cause a core
  dump. ie join a channel, and a topic change appears immediately after.
- added /set cdcc on/off for turning your cdcc off.
- getsets() leaking memory. drendite found this. hops version also leaks.
- fixed small problem whitedrgn found with hooking 364.
- seems that /oper <enter> <enter> would core the client.
- small patch to p_quit() logmsg() needs the channels even when ignored.
- small problem someone noticed with /quit random msgs and /set log on. 
- changes to convert_output_format() in an attempt at a speedup.
- dcc closeall seg fixed.
- Added function to return what the client currently thinks the channel
  topic is $topic() or $topic(#channel)

* Thu Jul 09 1998 Rod Cordova <rcordova@ethernet.org>
- Upgraded to version 75p1

* Wed Jul 01 1998 Rod Cordova <rcordova@ethernet.org>
- Upgraded to version 75
- incorporated the tcl-1.5-linux.o object into the binary for tcl support

* Thu Apr 02 1998 Rod Cordova <rcordova@ethernet.org>
- fixed the post install since it was not echo'ing properly after install
- applied the fixpack74p4.tgz to the source code
- incorporated the tcl.o object into the binary for tcl support
- stripped the BitchX binary and the wserv binary to reduce the size of
  the package

* Sat Mar 28 1998 Rod Cordova <rcordova@ethernet.org>
- upgraded to version 74p4

* Fri Feb 27 1998 Andrzej K. Brandt <andy@monk.cs.net.pl>
- upgraded to patchlevel 2

* Sun Feb 15 1998 Andrzej K. Brandt <andy@monk.cs.net.pl>
- backported from an SRPM made for RH 5.0 distribution (glibc)
